#pragma once
#include <stdlib.h>
#include <vector>
#include "voiddelegate.h"
#include <vcclr.h>
#include "dwmapi.h"
#define EA_NONE 0
#define EA_STARTING 1
#define EA_ENDING 2
#define EA_FADINGS  4
#define TASKSTYLE (WS_VISIBLE | WS_BORDER)

using namespace std;
typedef struct Window
{
	HWND WindowHandle;
	RECT WindowSourceRECT;
	HTHUMBNAIL ThumbID;
	//RECT Target;
	long targetOffsetLeft;
	long targetOffsetTop;
	long targetOffsetRight;
	long targetOffsetBottom;
	byte opacity;
	byte baseOpacity;
} * pWindow;

class ExposeAnimator
{
public:
	ExposeAnimator(HWND target, voiddelegate^ callback);
	void StartExpose();
	void AbortExpose();
	void OnMouseMove(System::Double x, System::Double y);
	void OnMouseClick(System::Double x, System::Double y);

	void OnRender();

public:
	~ExposeAnimator(void);


private:
	void Reset();
	void GetVisibleWindows();
	void ComputeTargets();
	void InitAnimation(int animState);
	void InitFadings();
	long hitTest(double x, double y);
	gcroot< voiddelegate^> m_fEndCallback;
	HWND m_hTarget;
	vector<Window*> m_lWindows;
	LONGLONG m_nAnimStart;
	LONGLONG m_nAnimEnd;
	LONGLONG m_nDuration;

	LONGLONG m_nFadingStart;
	LONGLONG m_nFadingEnd;
	LONGLONG m_nFadingDuration;

	int m_nAnimState;
	long m_nWindowsCount;
	long m_nDepth;
	long m_nCellWidth,m_nCellHeight;
	long m_nLastWindowIndex;
	long m_nFadingIn,m_nFadingOut;
	//CAtlList<Window*> m_lWindows;
	
};
