#include "StdAfx.h"
#include "ExposeWindow.h"
#include "dwmapi.h"
#include <msclr\event.h>
using namespace System;
using namespace System::Windows;
using namespace System::Windows::Input;
using namespace System::Windows::Interop;
using namespace System::Windows::Media;

ExposeWindow::ExposeWindow(void)
{
	System::Windows::Controls::Grid ^ grid = gcnew System::Windows::Controls::Grid();
	
	this->Content = grid;
	this->m_bExposing = false;
	this->m_bExposeEnding=false;
	m_oStopwatch = gcnew System::Diagnostics::Stopwatch();
	this->ShowInTaskbar = false;
	this->Topmost = true;
	this->WindowStyle = System::Windows::WindowStyle::None;
	this->ResizeMode = System::Windows::ResizeMode::NoResize;
	this->Loaded+= gcnew RoutedEventHandler(this,&ExposeWindow::OnWindowLoaded);
	this->Closing+= gcnew System::ComponentModel::CancelEventHandler(this,&ExposeWindow::OnWindowClosing);
	this->MouseMove+= gcnew MouseEventHandler(this,&ExposeWindow::Window_MouseMove);
	this->MouseDown+= gcnew MouseButtonEventHandler(this,&ExposeWindow::Window_MouseDown);
	
	
}


void ExposeWindow::OnWindowLoaded(Object^ sender, RoutedEventArgs^ args)
{
	this->Hide();

	m_oStopwatch->Start();
	RECT desktopRect;
	GetWindowRect(GetDesktopWindow(),&desktopRect);
	this->Left = 0.0;
	this->Top = 0.0;
	this->Width = desktopRect.right;
	this->Height = desktopRect.bottom;
	WindowInteropHelper wih(this);
	m_oHandle = wih.Handle;
	HwndSource^ hwndSource = HwndSource::FromHwnd(m_oHandle);
	Color backColor;
	backColor.A=180;
	backColor.B=0;
	backColor.G=0;
	backColor.B=0;
	this->Background = Brushes::Transparent;
	hwndSource->CompositionTarget->BackgroundColor = backColor;

	
	MARGINS m;
	m.cxLeftWidth = desktopRect.right/2;
	m.cxRightWidth = desktopRect.right - m.cxLeftWidth;
	m.cyTopHeight = desktopRect.bottom/2;
	m.cyBottomHeight = desktopRect.bottom - m.cyTopHeight;


	m_onAnimEnd = gcnew voiddelegate(this,&ExposeWindow::OnExposingEnd);
	m_oAnimator = new ExposeAnimator((HWND) m_oHandle.ToPointer(),m_onAnimEnd);

	CompositionTarget::Rendering+=gcnew EventHandler(this,&ExposeWindow::OnRendering);
	
	DwmExtendFrameIntoClientArea((HWND) m_oHandle.ToPointer(),&m);
	//LoadLibrary("User32");
	m_HookTriggerDelegate = gcnew hooktriger(this,&ExposeWindow::OnHookTriggered);
	//pin_ptr<hooktriger^ >cb = &hookDel;
	//HMODULE hInstance = LoadLibrary(L"User32");
	m_hHook = SetWindowsHookEx(WH_KEYBOARD_LL, (HOOKPROC)System::Runtime::InteropServices::Marshal::GetFunctionPointerForDelegate(m_HookTriggerDelegate).ToPointer(),NULL,NULL);
	
	
}
void ExposeWindow::OnWindowClosing(Object^ sender, System::ComponentModel::CancelEventArgs^ args)
{
	UnhookWindowsHookEx(m_hHook);
	m_hHook = NULL;
}

LRESULT ExposeWindow::OnHookTriggered(          int code,
    WPARAM wParam,
    LPARAM lParam
)
{
	if(wParam == WM_KEYDOWN)
	{
		KBDLLHOOKSTRUCT * keyInfo = (KBDLLHOOKSTRUCT *)lParam;
		if(keyInfo->vkCode == VK_F12)
		{
			this->Show();
			OnExposeRequested();
		}
	}


	return CallNextHookEx(m_hHook,code,wParam,lParam);
	
}
void ExposeWindow::OnExposeRequested()
{
	if(m_bExposing)
	{
		this->AbortExposing();
	}
	else
	{
		this->m_bExposing = true;
		this->m_oAnimator->StartExpose();
	}
}
void ExposeWindow::AbortExposing()
{
	if(!this->m_bExposeEnding)
	{
		this->m_bExposeEnding = true;
		this->m_oAnimator->AbortExpose();
	}
	
}

void ExposeWindow::OnExposingEnd()
{
	
	this->m_bExposeEnding = false;
	this->m_bExposing = false;
	this->Hide();
}

void ExposeWindow::OnRendering(Object^ sender,EventArgs^ e)
{
	
	this->m_oAnimator->OnRender();
}
void ExposeWindow::Window_MouseMove(System::Object ^sender, System::Windows::Input::MouseEventArgs ^e)
{
	Point p = e->GetPosition(this);
		 m_oAnimator->OnMouseMove(p.X,p.Y);
}
void ExposeWindow::Window_MouseDown(System::Object ^sender, System::Windows::Input::MouseButtonEventArgs ^e)
{
	 Point p = e->GetPosition(this);
		 m_oAnimator->OnMouseClick(p.X,p.Y);
}
//void ExposeWindow::OnHook